-- SCRIPT FOR 3DSMAX
-- Written By ElectroKidd (following the Tutorial of MAXSCRIPT... the easyway)
-- * select the Geometry you want 
-- * Run the script
-- * copy the result in a CPP...

tmesh = snapshotAsMesh selection[1]
model_name = "Model"
out_name = ((GetDir #export)+"/testmesh1.dat")
out_file = createfile out_name
num_tvverts = tmesh.numtverts
num_verts = tmesh.numverts 
num_faces = tmesh.numfaces

-- Vertex
format "float %_vertex[%][3] = {\n" model_name num_verts to:out_file
for v = 1 to num_verts do
(
	vert = getVert tmesh v
	format "{%,%,%}" vert.x vert.y vert.z to:out_file	
	if ( v < num_verts) then format "," to:out_file	
	if ( (v / 5) * 5 == v) then format "\n" to:out_file	
)
format "} ; \n\n" to:out_file	

-- Mapping vertex
format "float %_mapping[%][2] = {\n" model_name num_tvverts to:out_file
for v = 1 to num_tvverts do
(
	vert = getTVert tmesh v
	format "{%,%}" vert.x vert.y to:out_file	
	if ( v < num_tvverts) then format "," to:out_file	
	if ( (v / 5) * 5 == v) then format "\n" to:out_file	
)
format "} ; \n\n" to:out_file	

-- Faces
format "\n" to:out_file
format "int %_faces[%][3] = {\n" model_name num_faces to:out_file
for f = 1 to num_faces do
(
	face = getFace tmesh f
	format "{%,%,%}" (face.x as Integer) (face.y as Integer) (face.z as Integer) to:out_file
	if ( f < num_faces) then format "," to:out_file	
	if ( (f / 10) * 10 == f) then format "\n" to:out_file	
	
)
format "} ; \n\n" to:out_file	

-- Normals
format "\n" to:out_file
format "int %_Normals[%][3] = {\n" model_name num_faces to:out_file
for f = 1 to num_faces do
(
	vers = getFaceNormal tmesh f
	format "{%,%,%}" vers.x vers.y vers.z to:out_file
	if ( f < num_faces) then format "," to:out_file	
	if ( (f / 10) * 10 == f) then format "\n" to:out_file	
	
)
format "} ; \n\n" to:out_file	

-- Faces Mapping
format "\n" to:out_file
format "int %_mapfaces[%][3] = {\n" model_name num_faces to:out_file
for f = 1 to num_faces do
(
	face = getTVFace tmesh f
	format "{%,%,%}" (face.x as Integer) (face.y as Integer) (face.z as Integer) to:out_file
	if ( f < num_faces) then format "," to:out_file	
	if ( (f / 10) * 10 == f) then format "\n" to:out_file		
)
format "} ; \n\n" to:out_file	



close out_file

edit out_name


