#include <gccore.h>
#include "..\include\camera.h"
#include "..\include\GrObject.h"
#include <list>


#pragma once 
#define NUM_TEXTURES 20
#define DEFAULT_FIFO_SIZE 256 * 1024

#define FRAMEWORK CFrameWork::GetInstance() 
#define CAMERA 	  FRAMEWORK->GetCamera()

#define SET_VECTOR( v, x1, y1, z1) { v.x = x1 ; v.y = y1 ; v.z = z1 ;}

extern Vector stdAxisX ;
extern Vector stdAxisY ;
extern Vector stdAxisZ ;

//--------------------------------------------------------------
void DEBUG( char*) ;
void pressAnyButton() ;
void CheckFat() ;
//--------------------------------------------------------------
class CFrameWork {
	friend class CGraphicObject ;
	friend class CVtxObject ;
	typedef std::list<CGraphicObject*> 	CListGeom ;
	
private:		
	static CFrameWork*	  		s_SingleInstance ;

	CCamera				  		m_cCamera ;
	CListGeom				 	m_lGeom ;
	CListGeom				 	m_lSel ;
	
   // texture gmr 
	int							m_nTexture ;			
	unsigned char 				*texturedata[NUM_TEXTURES];
	GXTexObj 					texObj[NUM_TEXTURES] ;
	
   // auto-pointer
	BOOL						m_bPointer3D ;
	CGraphicObject* 			m_pPointer ;
	
public:
	
	
public:
	CFrameWork() ;
	static inline CFrameWork*	GetInstance() { return s_SingleInstance; };
	inline 		CCamera* 	GetCamera() { return &m_cCamera; } ;
	inline		GXRModeObj* GetVMode() { return vmode ; };
	void        SetFb0() ;

private:	
	
	void		StartGX( void) ;
	void		StopGX( void) ;
	

	void		UpdateBeforeNewFrame() ;
	void		AddObject( CGraphicObject* pGeom) ;  
	void		RemoveObject( CGraphicObject* pGeom) ;	

public:	
	
	void		InitVideo( void) ;	
	void		SetPointer( CGraphicObject* pGeom, BOOL bAs3D) ;	
	int			CreateTextureID( const u8 *PngPointer, BOOL bWithAlpha=FALSE) ;	
		
	int			      DoPick( unsigned int uMaskID = 0xFFFF) ;
   CGraphicObject*   GetPick( int n=0) ;
	
	void 		RenderScene( void) ;
	void		EndFrame( void) ;
	void		DeleteList( void) ;
	
	
private:	
	void		ResetVideo( void) ;

private:
	unsigned int 	*xfb[2] ; 	// Double buffered
	int 			whichfb ; 					   	// Switch
	GXRModeObj 		*vmode; 					   	// Menu video mode
	unsigned char 	gp_fifo[DEFAULT_FIFO_SIZE] ATTRIBUTE_ALIGN (32);	
	int 			screenheight;
	int 			screenwidth; 
} ;


