#include <gccore.h>

#pragma once
//--------------------------------------------------------------
class CGraphicObject {
public:
    CGraphicObject() ;
	virtual ~CGraphicObject() ;
	void SetID( int nID) ;
	void SetPos( float dX, float dY, float dZ) ;
   void SetPos( Vector& v) ;
	void SetPosScreenPix( int WiimoteX, int WiimoteY) ;
   void SetPosScreen( float  dX, float dY) ;
	void SetOrient( float dA, float dB, float dC) ;	
	virtual void Render() ;	
	void SetBlink( bool bBlink) ;
	bool HitBox( Vector& ptSrc, Vector& vtDir, float* dDist) ;	
   inline int GetNPass() {return m_nPass;} ;
   inline int GetID() { return m_nID ;} ;
	
	
private:
			void PrepareRef() ;
	virtual void OnRender() = 0 ;
	virtual void CalculateExtension() = 0;
	
public:
   int      m_nPass ;
	int		m_nID ;
   int		m_nTrasp ; // 0 visible 16-full trasparent
	int      m_nAutoBlink ;
	Vector   m_Pos ;
	float	   m_dA ;
	float	   m_dB ;
	float	   m_dC ;
	bool	   m_bOnScreen ;
	Mtx 	   m_model ;
	Vector   m_ptMin ;
	Vector   m_ptMax ;
} ;

//--------------------------------------------------------------
class CVtxObject : public CGraphicObject
{
public:
	CVtxObject() ;
	void SetUp( int nTexture, int nFaces, 
				float Model_vertexes[][3], float Model_mapping[][2], 
				int Model_faces[][3], int Model_mapfaces[][3]) ;
	void OnRender() ;
	void CalculateExtension() ;	
	
protected:
	int 	m_nTexture ;
	int		m_nFaces ;
	float* 	m_Model_vertex ;
	float*  m_Model_mapping ; 
	int*  	m_Model_faces ;
	int*	m_Model_mapfaces ;
} ;
