/****************************************************************************
*	EK's ITALIAN parking                                                     *
*	        																                   *
*	17.04.09 intro.cpp             										             *
* 	        																                   *
****************************************************************************/

#include "..\include\MyModels.h"
#include "..\include\SideWalk.h"
#include "..\include\intro.h"
#include "..\include\math.h"

CIntro::CIntro() 
{
   m_nTime = 0 ;
   pTxt = new CTextObj ;
   pTxt->SetPosScreen( 0.0, 0.30) ;      
   pTxt->SetString("ElectroKidd Presents", 0, 0.02, 0.02) ;
   
   pTxt = new CTextObj ;
   pTxt->SetPosScreen( 0, 0) ;   
}

CIntro::~CIntro() 
{
   FRAMEWORK->DeleteList() ;
}
   
int
CIntro::DoIntro() 
{
   Vector pos ;
   int    nFadeIn ;
   int    nFadeOut ;
   
   m_nTime++;
   //printf( "\x1b[4;10H %d", m_nTime) ;
 
   nFadeIn = (m_nTime % 120) / 2 ;
   if ( nFadeIn  < 16) 
      pTxt->m_nTrasp = 16-nFadeIn ;   
      
   nFadeOut = (119-(m_nTime % 120)) / 2 ;
   if ( nFadeOut  < 16) 
      pTxt->m_nTrasp = 16-nFadeOut ;
   
   if ( m_nTime == 1)
      pTxt->SetString("All Over the World...", 0, 0.075, 0.035, true) ;
   if ( m_nTime == 121)
      pTxt->SetString("... parking is easy...", 0, 0.075, 0.035, true) ;
   if ( m_nTime == 241)
      pTxt->SetString("... In Italy...", 0, 0.075, 0.035, true) ;
   if ( m_nTime == 361)
      pTxt->SetString("... That's is a...", 0, 0.075, 0.035, true) ;
   if ( m_nTime == 481)
      pTxt->SetString("...PUZZLE!", 1, 0.1, 0.1, true) ;
      
   if ( m_nTime == 600)
      CreateAll() ;
      
   if ( m_nTime > 600) {
      cameraSpline.GetAt( m_nTime/120.0, &pos) ;
      CAMERA->SetEye( pos.x, pos.y, pos.z) ;
      
      cameraSpline.GetAt( m_nTime/120.0+0.2, &pos) ;
      CAMERA->SetFocus( pos.x, pos.y, pos.z-0.2) ;
   }
   
   if ( WPAD_ButtonsDown(0) & (WPAD_BUTTON_A | WPAD_BUTTON_B))
      return false ;
   return true ;
}
 
 void
CIntro::CreateAll() 
{
   CTerrain* pTerrain ;
   CHouse*   pHouse ;
   CMy147*   p147 ;
   CTitle*   pTitle ;
   
   new CSky ;
   
   for ( int x = 0 ; x < 10 ; x++) {
      for ( int y = 0 ; y < 16 ; y++) {
         pTerrain = new CTerrain ;
         pTerrain->SetPos( x,y,0) ;
      }
   }
   
   pHouse = new CHouse ; pHouse->SetPos( 3,1,0); 
   pHouse = new CHouse ; pHouse->SetPos( 7,2,0); pHouse->SetOrient( 0,0, 90) ;
   pHouse = new CHouse ; pHouse->SetPos( 0,4,0); 
   pHouse = new CHouse ; pHouse->SetPos( 4,5,0); pHouse->SetOrient( 0,0, 90) ;
   pHouse = new CHouse ; pHouse->SetPos( 8,6,0); 
   pHouse = new CHouse ; pHouse->SetPos( 1,8,0); pHouse->SetOrient( 0,0, 90) ;
   pHouse = new CHouse ; pHouse->SetPos( 5,9,0); 
   pHouse = new CHouse ; pHouse->SetPos( 1,12,0); pHouse->SetOrient( 0,0, 90) ;
   pHouse = new CHouse ; pHouse->SetPos( 9,9,0); pHouse->SetOrient( 0,0, 90) ;
   pHouse = new CHouse ; pHouse->SetPos( 9,14,0); pHouse->SetOrient( 0,0, 90) ;
   pHouse = new CHouse ; pHouse->SetPos( 2, 15,0); 
   pHouse = new CHouse ; pHouse->SetPos( 6, 15,0); 
   
   p147 = new CMy147 ; p147->SetPos( 2,11,0) ;
   p147 = new CMy147 ; p147->SetPos( 4,11,0) ; p147->SetColor(1) ;
   p147 = new CMy147 ; p147->SetPos( 6,11,0) ;
   p147 = new CMy147 ; p147->SetPos( 3,12,0) ;
   p147 = new CMy147 ; p147->SetPos( 3,13,0) ; p147->SetColor(1) ;
   p147 = new CMy147 ; p147->SetPos( 6,12,0) ;
   p147 = new CMy147 ; p147->SetPos( 6,13,0) ; p147->SetColor(1) ;   
   p147 = new CMy147 ; p147->SetPos( 3,12,0) ; p147->SetOrient(0,0,90) ;
   p147 = new CMy147 ; p147->SetPos( 6,12,0) ; p147->SetOrient(0,0,90) ;p147->SetColor(1) ;
   
   pTitle = new CTitle ;
   pTitle->SetSize( 0.75, 0.75) ;
   pTitle->SetPosScreen( -0.36, -0.36) ;
   
   static Vector s[10] = { {5.75, 2.25, 1}, {5.75, 2.25, 1}, {5.25,7.75, 1.5}, 
                          {7.75, 7.25, 1}, {7.75, 10.75, 1.5}, 
                          {2.25, 10.75, 1}, {2.5, 7.5, 1}, 
                          {2.25, 2.25, 1.5}, {5.75, 2.25, 1}, {5.75, 2.25, 1}} ;
   cameraSpline.Init( 4, 10, s) ; 
 
   pTxt->SetPosScreen( -0.36, -0.36) ;
   pTxt->SetString( "Press A & B", 1, 0.1, 0.04 ) ;
   
   

}
