/****************************************************************************
*	EK's ITALIAN parking                                                    *
*	        																*
*	17.04.09 MyModels.cpp             										*
* 	        																*
****************************************************************************/

#include "..\include\MyModels.h"
#include "..\include\framework.h"
#include "My147_png.h"
#include "My147_red_png.h"
#include "MyPointer_png.h"
#include "Terrain_png.h"
#include "bus_png.h"
#include "House_png.h"
#include "title_png.h"
#include "Sky_png.h"
#include "Shadow_png.h"

int CPointer::m_nTexID = -1 ;
int CTerrain::m_nTexID = -1 ;
int CMy147::m_nTexID1 = -1 ;
int CMy147::m_nTexID2 = -1 ;
int CBus::m_nTexID = -1 ;
int CHouse::m_nTexID = -1 ;
int CTitle::m_nTexID = -1 ;
int CSky::m_nTexID = -1 ;
int CShadow::m_nTexID = -1 ;

// ---------------------------------------------------------------------------
// ---------------------------------------------------------------------------
// ---------------------------------------------------------------------------
// ---------------------------------------------------------------------------

float Model_vertex[4][3] = {
{0.075, -0.075, 0},{0.075,0.075,0},{-0.075,0.075,0},{-0.075,-0.075,0}} ; 
float Model_mapping[4][2] = {
{1.0,1.0},{1.0,0.0},{0.0,0.0},{0.0,1.0}} ; 
int Model_faces[2][3] = {
{1,2,3},{3,4,1}} ; 
int Model_mapfaces[2][3] = {
{1,2,3},{3,4,1}} ; 
int Model_nFace = 2 ;

CPointer::CPointer() 
{
	if ( m_nTexID < 0)	
		m_nTexID = FRAMEWORK->CreateTextureID( MyPointer_png, TRUE) ;
   SetUp( m_nTexID, Model_nFace, Model_vertex, Model_mapping, 
	      	 Model_faces, Model_mapfaces) ;
}

//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
CTitle::CTitle() 
{
   m_nPass = 2 ;
	if ( m_nTexID < 0)	
		m_nTexID = FRAMEWORK->CreateTextureID( title_png, TRUE) ;
   SetSize(1,1) ;
   SetUp( m_nTexID, Model_nFace, modelTitle_vtx, Model_mapping, 
	      	 Model_faces, Model_mapfaces) ;
}

void
CTitle::SetSize( float w, float h)
{
   modelTitle_vtx[0][0] = w ;
   modelTitle_vtx[0][1] = 0 ;
   modelTitle_vtx[0][2] = 0 ;
   
   modelTitle_vtx[1][0] = w ;
   modelTitle_vtx[1][1] = h ;
   modelTitle_vtx[1][2] = 0 ;

   modelTitle_vtx[2][0] = 0 ;
   modelTitle_vtx[2][1] = h ;
   modelTitle_vtx[2][2] = 0 ;
   
   modelTitle_vtx[3][0] = 0 ;
   modelTitle_vtx[3][1] = 0 ;
   modelTitle_vtx[3][2] = 0 ;
   
}



// ---------------------------------------------------------------------------
// ---------------------------------------------------------------------------
// ---------------------------------------------------------------------------
// ---------------------------------------------------------------------------

float Model147_vertex[30][3] = {
{1.34771,0.833773,0.0938591},{1.50284,0.833773,-0.00715731},{1.67601,0.833773,-0.00354958},{1.74817,0.833773,0.10829},{1.92134,0.721986,0.132338},
{1.92134,0.721986,0.322352},{1.40182,0.833773,0.47267},{1.0543,0.725129,0.660272},{0.226918,0.725129,0.660272},{-0.00518871,0.833773,0.443809},
{0.00563448,0.833773,0.133544},{0.103043,0.833773,0.101075},{0.214883,0.833773,-0.00354943},{0.380838,0.833773,0.0108815},{0.467423,0.833773,0.083036},
{1.34771,0.0189427,0.093859},{1.50284,0.0189428,-0.00715734},{1.67601,0.0189428,-0.00354961},{1.74817,0.0189428,0.10829},{1.92134,0.13073,0.132338},
{1.92134,0.13073,0.322352},{1.40182,0.0189427,0.47267},{1.0543,0.127587,0.660272},{0.226919,0.127587,0.660272},{-0.00518861,0.0189426,0.443809},
{0.00563458,0.0189426,0.133544},{0.103043,0.0189426,0.101075},{0.214883,0.0189426,-0.00354947},{0.380838,0.0189426,0.0108815},{0.467423,0.0189426,0.0830359}
} ; 

float Model147_mapping[76][2] = {
{0.0,0.0},{0.0394237,0.0},{0.0763102,0.0},{0.104654,0.0},{0.141541,0.0},
{0.401729,0.805941},{0.404426,0.877751},{0.386859,0.163093},{0.635493,0.163093},{0.589963,0.793429},
{0.698562,0.0},{0.720428,0.0},{0.753042,0.0},{0.788518,0.0},{0.81252,0.0},
{1.0,0.0},{0.0,1.0},{0.0394237,1.0},{0.0763102,1.0},{0.104654,1.0},
{0.141541,1.0},{0.0458434,0.810145},{0.0475057,0.880478},{0.386859,0.210168},{0.635493,0.210168},
{0.605132,0.624231},{0.698562,1.0},{0.720428,1.0},{0.753042,1.0},{0.788518,1.0},
{0.81252,1.0},{1.0,1.0},{0.676735,0.0691361},{0.748876,0.020164},{0.829304,0.0220761},
{0.86272,0.0765177},{0.416637,0.863211},{0.371522,0.971782},{0.70154,0.253362},{0.538839,0.344253},
{0.156791,0.343503},{0.048063,0.238045},{0.0533605,0.0872062},{0.0986313,0.0715085},{0.150667,0.0207429},
{0.227735,0.0279106},{0.267887,0.0630707},{0.67251,0.0804978},{0.743511,0.0190286},{0.84223,0.0195636},
{0.883332,0.0845347},{0.957282,0.0960364},{0.950358,0.188136},{0.700081,0.254358},{0.539642,0.342906},
{0.159545,0.348246},{0.0497184,0.250219},{0.0526192,0.0887869},{0.0974109,0.0685536},{0.132043,0.0220462},
{0.227501,0.0182684},{0.265665,0.081235},{0.952038,0.101499},{0.926164,0.19853},{0.0676053,0.863042},
{0.10419,0.976282},{0.41597,0.660536},{0.553625,0.925503},{0.0552988,0.665891},{0.482619,0.624053},
{0.819515,0.933672},{0.891765,0.812648},{0.482594,0.666479},{0.919027,0.666079},{0.0392918,0.624046},
{0.0392671,0.666473}} ; 


int Model147_faces[56][3] = {
{1,2,17},{1,17,16},{2,3,18},{2,18,17},{3,4,19},{3,19,18},{4,5,20},{4,20,19},{5,6,21},{5,21,20},
{6,7,22},{6,22,21},{7,8,23},{7,23,22},{8,9,24},{8,24,23},{9,10,25},{9,25,24},{10,11,26},{10,26,25},
{11,12,27},{11,27,26},{12,13,28},{12,28,27},{13,14,29},{13,29,28},{14,15,30},{14,30,29},{15,1,16},{15,16,30},
{4,6,5},{4,7,6},{3,7,4},{2,7,3},{1,7,2},{15,7,1},{15,8,7},{15,9,8},{15,10,9},{15,11,10},
{15,12,11},{15,13,12},{15,14,13},{19,20,21},{19,21,22},{18,19,22},{17,18,22},{16,17,22},{30,16,22},{30,22,23},
{30,23,24},{30,24,25},{30,25,26},{30,26,27},{30,27,28},{30,28,29}} ; 


int Model147_Normals[56][3] = {
{-0.545673,0.0,-0.837998},{-0.545673,0.0,-0.837998},{0.0208288,0.0,-0.999783},{0.0208288,0.0,-0.999783},{0.840297,1.4772e-007,-0.542126},{0.840297,1.4772e-007,-0.542126},{0.137549,0.0,-0.990495},{0.137549,0.0,-0.990495},{1.0,0.0,0.0},{1.0,0.0,0.0},
{0.277944,0.0,0.960597},{0.277944,0.0,0.960597},{0.475031,0.0,0.879969},{0.475031,0.0,0.879969},{0.0,0.0,1.0},{0.0,0.0,1.0},{-0.682032,0.0,0.731322},{-0.682032,-1.5799e-007,0.731322},{-0.999392,0.0,-0.0348626},{-0.999392,0.0,-0.0348626},
{-0.316227,0.0,-0.948684},{-0.316227,0.0,-0.948684},{-0.683157,0.0,-0.730271},{-0.683157,0.0,-0.730271},{0.0866298,0.0,-0.996241},{0.0866298,0.0,-0.996241},{0.640184,0.0,-0.768222},{0.640184,0.0,-0.768222},{0.0122941,0.0,-0.999924},{0.012294,0.0,-0.999924},
{0.542346,0.840155,0.0},{0.274668,0.925419,0.261071},{0.0,1.0,0.0},{0.0,1.0,1.23679e-007},{-3.51519e-007,1.0,0.0},{0.0,1.0,0.0},{-0.128435,0.942676,0.308005},{-1.28269e-007,0.982745,0.184967},{0.199027,0.944675,0.260726},{0.0,1.0,1.88325e-007},
{-1.92109e-007,1.0,-5.7633e-007},{-1.72718e-007,1.0,-1.8463e-007},{-4.01005e-007,1.0,4.81206e-007},{0.542346,-0.840155,0.0},{0.274669,-0.925418,0.261071},{1.20186e-007,-1.0,0.0},{1.1925e-007,-1.0,0.0},{1.28158e-007,-1.0,0.0},{0.0,-1.0,0.0},{-0.128434,-0.942676,0.308005},
{1.41594e-007,-0.982745,0.184966},{0.199027,-0.944675,0.260726},{0.0,-1.0,0.0},{0.0,-1.0,0.0},{0.0,-1.0,0.0},{1.30327e-007,-1.0,0.0}} ; 


int Model147_mapfaces[56][3] = {
{1,2,18},{1,18,17},{2,3,19},{2,19,18},{70,73,76},{70,76,75},{4,5,21},{4,21,20},{67,6,22},{67,22,69},
{6,7,23},{6,23,22},{37,38,66},{37,66,65},{8,9,25},{8,25,24},{68,10,72},{68,72,71},{10,26,74},{10,74,72},
{11,12,28},{11,28,27},{12,13,29},{12,29,28},{13,14,30},{13,30,29},{14,15,31},{14,31,30},{15,16,32},{15,32,31},
{36,53,52},{36,39,53},{35,39,36},{34,39,35},{33,39,34},{47,39,33},{47,40,39},{47,41,40},{47,42,41},{47,43,42},
{47,44,43},{47,45,44},{47,46,45},{51,63,64},{51,64,54},{50,51,54},{49,50,54},{48,49,54},{62,48,54},{62,54,55},
{62,55,56},{62,56,57},{62,57,58},{62,58,59},{62,59,60},{62,60,61}} ; 


int Model147_nFace = 56 ;

CMy147::CMy147()
{
	if ( m_nTexID1 < 0)
		m_nTexID1 = FRAMEWORK->CreateTextureID( My147_png) ; 	
		
	if ( m_nTexID2 < 0)
		m_nTexID2 = FRAMEWORK->CreateTextureID( My147_red_png) ; 	

	SetUp( m_nTexID1, Model147_nFace, Model147_vertex, Model147_mapping, 
  					     Model147_faces, Model147_mapfaces) ;
}

void
CMy147::SetColor( int i) 
{
	m_nTexture = i ? m_nTexID2 : m_nTexID1 ;
}

// ---------------------------------------------------------------------------
// ---------------------------------------------------------------------------
// ---------------------------------------------------------------------------
// ---------------------------------------------------------------------------
float Model2_vertex[4][3] = {
{0.0, 0.0, 0}, {1.0,0.0,0},{1.0,1.0,0},{0.0,1.0,0}} ; 

float Model2_mapping[4][2] = {
{0.0,0.0},{1.0,0.0},{1.0,1.0},{0.0,1.0}} ; 

int Model2_faces[2][3] = {
{1,2,3},{3,4,1}} ; 

int Model2_mapfaces[2][3] = {
{1,2,3},{3,4,1}} ; 

int Model2_nFace = 2 ;

CTerrain::CTerrain() 
{
	if ( m_nTexID < 0)
		m_nTexID  = FRAMEWORK->CreateTextureID( Terrain_png) ; 	

	SetUp( m_nTexID, Model2_nFace, Model2_vertex, Model2_mapping, 
	          Model2_faces, Model2_mapfaces) ;
}

// ---------------------------------------------------------------------------
// ---------------------------------------------------------------------------
// ---------------------------------------------------------------------------
// ---------------------------------------------------------------------------
float ModelBus_vertex[48][3] = {
{2.59248,0.0512233,0.0851444},{2.50697,0.0525149,-0.00353598},{2.36444,0.05335,-0.000368867},{2.26942,0.0531237,0.0914787},{2.25991,0.0521862,0.205496},
{1.00886,0.0598978,0.189661},{0.888515,0.0621465,0.0154669},{0.717485,0.0631819,0.0154669},{0.619291,0.0621456,0.202329},{0.05206,0.109147,0.256251},
{0.0871378,0.105197,0.955903},{2.2615,0.0461447,0.896678},{2.21237,0.0470567,0.826259},{2.29788,0.0491164,0.530933},{2.68527,0.0990412,0.429425},
{2.69698,0.100473,0.257206},{2.5988,0.0501347,0.205496},{2.59749,0.878985,0.0923682},{2.51198,0.880276,0.00368784},{2.36945,0.881111,0.00685495},
{2.27443,0.880885,0.0987025},{2.26492,0.879947,0.21272},{1.01387,0.887659,0.196884},{0.893526,0.889908,0.0226908},{0.722496,0.890943,0.0226908},
{0.624302,0.889907,0.209553},{0.0565377,0.848831,0.262706},{0.0924628,0.88688,0.916231},{2.26651,0.873906,0.903902},{2.21738,0.874818,0.833483},
{2.28677,0.827188,0.592349},{2.68965,0.824046,0.435753},{2.70137,0.825478,0.263533},{2.60381,0.877896,0.21272},{0.0963923,0.0652345,0.211093},
{0.0436483,0.103399,0.912096},{0.101403,0.892996,0.218317},{0.048126,0.843083,0.918551},{0.0603615,0.0861132,0.928884},{0.0874518,0.0591188,0.909007},
{2.29409,0.0920302,0.943387},{0.0650442,0.859865,0.935635},{0.0915859,0.839988,0.962315},{2.29853,0.826821,0.9498},{2.28236,0.0980443,0.585986},
{2.68206,0.147922,0.481331},{2.30289,0.876878,0.538157},{2.68586,0.774309,0.486798}} ; 

float ModelBus_mapping[76][2] = {
{0.112872,0.376061},{0.139279,0.34464},{0.183292,0.345762},{0.212633,0.378306},{0.215567,0.418705},
{0.601896,0.413094},{0.639062,0.351373},{0.691876,0.351373},{0.722196,0.417583},{1.1636,0.372278},
{1.15037,1.10179},{0.215065,0.663607},{0.230238,0.638656},{0.203838,0.534015},{0.0843088,0.49789},
{0.0806944,0.436868},{0.110916,0.418705},{0.100853,0.367915},{0.1275,0.339336},{0.171911,0.340357},
{0.201519,0.369957},{0.20448,0.406701},{0.594313,0.401598},{0.631816,0.34546},{0.68511,0.34546},
{0.715704,0.40568},{1.1636,0.372278},{0.881416,0.633422},{0.203974,0.629448},{0.219284,0.606755},
{0.186587,0.194234},{0.0720308,0.478722},{0.0683836,0.423221},{0.0988794,0.406701},{0.883668,0.420688},
{1.16676,1.05614},{0.878641,0.408505},{1.16676,1.05614},{1.16042,1.0738},{0.886417,0.667976},
{0.318584,1.08874},{1.16042,1.0738},{1.15037,1.10179},{0.318584,1.08874},{0.323016,0.716049},
{0.172489,0.606457},{0.192644,0.51158},{0.658586,0.192041},{0.801869,0.74759},{0.536413,0.751314},
{0.80831,0.954952},{0.542855,0.958677},{0.123068,0.0674888},{0.813413,0.0675148},{0.123068,0.293265},
{0.813413,0.293291},{0.149788,0.735576},{0.149251,0.715171},{0.420209,0.733955},{0.419672,0.71355},
{0.154659,0.920878},{0.15332,0.869955},{0.40788,0.877849},{0.169676,0.879277},{0.224504,0.246492},
{0.424342,0.931369},{0.431876,0.880591},{0.634439,0.138948},{0.184663,0.810775},{0.389297,0.809548},
{0.16833,0.802326},{0.167578,0.773735},{0.405181,0.800906},{0.40443,0.772316},{0.150312,0.755538},
{0.420733,0.753917}} ; 


int ModelBus_faces[92][3] = {
{1,2,19},{1,19,18},{2,3,20},{2,20,19},{3,4,21},{3,21,20},{4,5,22},{4,22,21},{5,6,23},{5,23,22},
{6,7,24},{6,24,23},{7,8,25},{7,25,24},{8,9,26},{8,26,25},{9,35,37},{9,37,26},{10,36,38},{10,38,27},
{11,41,44},{11,44,43},{12,13,30},{41,30,44},{13,45,31},{13,47,30},{45,46,48},{45,48,31},{15,16,33},{46,33,48},
{16,17,34},{16,34,33},{17,1,18},{17,18,34},{40,13,12},{35,13,40},{9,13,35},{9,14,13},{15,17,16},{14,17,15},
{7,9,8},{6,9,7},{6,14,9},{5,14,6},{5,17,14},{4,17,5},{3,17,4},{2,17,3},{1,17,2},{28,29,30},
{37,28,30},{26,37,30},{26,30,47},{32,33,34},{47,32,34},{24,25,26},{23,24,26},{23,26,47},{22,23,47},{22,47,34},
{21,22,34},{20,21,34},{19,20,34},{18,19,34},{35,10,37},{27,37,10},{10,35,36},{39,36,35},{36,39,38},{42,38,11},
{37,27,28},{38,42,27},{11,39,40},{28,42,43},{44,30,29},{40,39,35},{43,42,11},{11,40,41},{12,41,40},{28,43,29},
{44,29,43},{30,41,12},{38,39,11},{27,42,28},{13,14,45},{48,33,32},{13,31,47},{45,14,46},{15,46,14},{47,31,32},
{48,32,31},{33,46,15}} ; 


int ModelBus_Normals[92][3] = {
{0.719867,0.00169954,-0.69411},{0.719868,0.00169973,-0.694109},{-0.0221632,0.00885861,-0.999715},{-0.0221632,0.00885862,-0.999715},{-0.694971,0.0104813,-0.718961},{-0.694971,0.0104813,-0.718961},{-0.996523,0.00675714,-0.0830421},{-0.996523,0.00675714,-0.0830421},{0.0127098,0.00864898,-0.999882},{0.0127098,0.00864896,-0.999882},
{0.822745,-2.01184e-005,-0.56841},{0.822745,-2.01105e-005,-0.56841},{5.28257e-005,0.00872628,-0.999962},{5.28247e-005,0.00872628,-0.999962},{-0.885203,0.00941768,-0.46511},{-0.885203,0.00941768,-0.46511},{-0.0167043,0.00882649,-0.999822},{-0.0167043,0.00882649,-0.999822},{-0.999899,0.00616445,-0.0127704},{-0.999899,0.00616445,-0.0127704},
{0.00561849,-0.00876044,0.999946},{0.00561851,-0.00876052,0.999946},{0.820128,2.87639e-005,-0.57218},{0.820128,2.85807e-005,-0.57218},{0.960532,-0.00824106,0.278048},{0.960532,-0.00824109,0.278048},{0.254445,-0.00997962,0.967036},{0.254444,-0.00997957,0.967036},{0.997677,-0.00663146,0.0678017},{0.997677,-0.00663148,0.067802},
{0.464033,0.00492133,-0.885804},{0.464033,0.00492118,-0.885804},{0.998602,-0.00558637,-0.052557},{0.998602,-0.00558637,-0.052557},{-0.006017,-0.999944,-0.00875171},{-0.00602042,-0.999943,-0.00883942},{-0.00605326,-0.999944,-0.00872646},{-0.00605327,-0.999944,-0.00872645},{0.446549,-0.894465,0.0229343},{0.164773,-0.974964,0.149313},
{-0.00605329,-0.999944,-0.00872645},{-0.00605327,-0.999944,-0.00872643},{-0.00605327,-0.999944,-0.00872644},{-0.00605327,-0.999944,-0.00872644},{-0.00605326,-0.999944,-0.00872644},{-0.00605326,-0.999944,-0.00872645},{-0.00605326,-0.999944,-0.00872645},{-0.00605326,-0.999944,-0.00872644},{-0.00605326,-0.999944,-0.00872644},{0.006017,0.999944,0.00875177},
{0.00602041,0.999943,0.00883941},{0.00605317,0.999944,0.00872677},{0.00605326,0.999944,0.00872654},{0.457341,0.888458,0.0384944},{0.176548,0.970144,0.166288},{0.00605318,0.999944,0.00872627},{0.0060533,0.999944,0.00872645},{0.00605329,0.999944,0.00872635},{0.00605328,0.999944,0.00872639},{0.00605329,0.999944,0.00872639},
{0.00605329,0.999944,0.00872638},{0.00605329,0.999944,0.0087264},{0.00605305,0.999944,0.00872667},{0.00605344,0.999944,0.0087265},{-0.708464,0.0104471,-0.70567},{-0.708464,0.0104471,-0.70567},{-0.711469,-0.702552,-0.015283},{-0.711369,-0.702653,-0.01527},{-0.709637,-0.00185284,0.704565},{-0.709637,-0.00185287,0.704565},
{-0.702905,0.711279,-0.00277162},{-0.70283,0.711352,-0.00277931},{-0.193945,-0.700405,0.68689},{-0.185611,0.690518,0.699094},{0.820128,2.76628e-005,-0.57218},{-0.711369,-0.702653,-0.01527},{-0.709637,-0.00185286,0.704565},{-0.000280852,-0.713301,0.700858},{-0.000281788,-0.713271,0.700889},{0.00822741,0.700833,0.713278},
{0.00822613,0.700863,0.713248},{0.82013,2.90426e-005,-0.572178},{-0.709637,-0.00185283,0.704566},{-0.702838,0.711344,-0.00277907},{0.960532,-0.00824386,0.278047},{0.997677,-0.00662658,0.0678031},{-0.960531,0.00824046,-0.27805},{0.263596,-0.682941,0.681256},{0.264892,-0.693785,0.669697},{0.274536,0.666689,0.692933},
{0.270431,0.6794,0.682116},{0.997677,-0.00663116,0.067803}} ; 


int ModelBus_mapfaces[92][3] = {
{57,58,60},{57,60,59},{2,3,20},{2,20,19},{3,4,21},{3,21,20},{4,5,22},{4,22,21},{5,6,23},{5,23,22},
{6,7,24},{6,24,23},{7,8,25},{7,25,24},{8,9,26},{8,26,25},{9,35,37},{9,37,26},{49,51,52},{49,52,50},
{53,54,56},{53,56,55},{12,13,30},{41,30,44},{61,64,63},{61,67,66},{64,69,70},{64,70,63},{71,72,74},{69,74,70},
{72,75,76},{72,76,74},{75,57,59},{75,59,76},{40,13,12},{35,13,40},{9,13,35},{9,14,13},{15,17,16},{14,17,15},
{7,9,8},{6,9,7},{6,14,9},{5,14,6},{5,17,14},{4,17,5},{3,17,4},{2,17,3},{1,17,2},{28,29,30},
{37,28,30},{26,37,30},{26,30,47},{32,33,34},{47,32,34},{24,25,26},{23,24,26},{23,26,47},{22,23,47},{22,47,34},
{21,22,34},{20,21,34},{19,20,34},{18,19,34},{35,10,37},{27,37,10},{10,35,36},{39,36,35},{36,39,38},{42,38,11},
{37,27,28},{38,42,27},{11,39,40},{28,42,43},{44,30,29},{40,39,35},{43,42,11},{11,40,41},{12,41,40},{28,43,29},
{44,29,43},{30,41,12},{38,39,11},{27,42,28},{61,62,64},{70,74,73},{61,63,67},{45,14,46},{15,46,14},{65,31,48},
{68,48,31},{74,69,71}} ; 

int ModelBus_nFace = 92 ;

CBus::CBus() 
{
	if ( m_nTexID < 0)
		m_nTexID  = FRAMEWORK->CreateTextureID( bus_png) ; 	

	SetUp( m_nTexID, ModelBus_nFace, ModelBus_vertex, ModelBus_mapping, 
	          ModelBus_faces, ModelBus_mapfaces) ;
}



float ModelHouse_vertex[8][3] = {
{-2.0,-1.0,0.0},{2.0,-1.0,0.0},{-2.0, 1.0,0.0},{2.0, 1.0,0.0},{-2.0,-1.0,2.0},
{2.0,-1.0,2.0},{-2.0, 1.0,2.0},{2.0, 1.0,2.0}} ; 

float ModelHouse_mapping[36][2] = {
{0.504374,0.999499},{0.000499516,0.504376},{0.999498,0.999502},{0.00162583,0.505691},{0.504377,0.502528},
{0.000499516,0.999501},{0.999502,0.502532},{0.00162583,0.996794},{0.999501,0.000499994},{0.9995,0.999501},
{0.000499517,0.9995},{0.000499517,0.9995},{0.000499636,0.000499517},{0.999501,0.000499994},{0.500684,0.0023455},
{0.997655,0.00234526},{0.997655,0.501161},{0.997655,0.501161},{0.500684,0.501162},{0.500684,0.0023455},
{0.506697,0.504855},{0.000497656,0.504851},{0.00050133,0.000497699},{0.00050133,0.000497699},{0.5067,0.000501364},
{0.506697,0.504855},{0.000499516,0.504376},{0.503007,0.504376},{0.503007,0.999501},{0.503007,0.999501},
{0.00162583,0.505691},{0.503272,0.505691},{0.503272,0.996794},{0.503272,0.996794},{0.999498,0.999502},
{0.504377,0.502528}} ; 


int ModelHouse_nFace = 12 ;

int ModelHouse_faces[12][3] = {
{1,3,4},{4,2,1},{5,6,8},{8,7,5},{1,2,6},{6,5,1},{2,4,8},{8,6,2},{4,3,7},{7,8,4},
{3,1,5},{5,7,3}} ; 


int ModelHouse_Normals[12][3] = {
{0.0,0.0,-1.0},{0.0,0.0,-1.0},{0.0,0.0,1.0},{0.0,0.0,1.0},{0.0,-1.0,0.0},{0.0,-1.0,0.0},{1.0,0.0,0.0},{1.0,0.0,0.0},{0.0,1.0,0.0},{0.0,1.0,0.0},
{-1.0,0.0,0.0},{-1.0,0.0,0.0}} ; 


int ModelHouse_mapfaces[12][3] = {
{9,10,11},{12,13,14},{15,16,17},{18,19,20},{21,22,23},{24,25,26},{27,28,29},{30,6,2},{31,32,33},{34,8,4},
{35,1,36},{5,7,3}} ; 

CHouse::CHouse() 
{
	if ( m_nTexID < 0)	
		m_nTexID = FRAMEWORK->CreateTextureID( house_png, FALSE) ;
   SetUp( m_nTexID, ModelHouse_nFace, ModelHouse_vertex, ModelHouse_mapping, 
	      	 ModelHouse_faces, ModelHouse_mapfaces) ;
}


float ModelSky_vertex[27][3] = {
{0.0,0.0,24.9977},{13.1433,0.0,21.2639},{4.0615,12.5,21.2639},{-10.6331,7.72542,21.2639},{-10.6331,-7.72543,21.2639},
{4.0615,-12.5,21.2639},{22.3607,0.0,11.178},{6.90983,21.2663,11.178},{-18.0902,13.1433,11.178},{-18.0902,-13.1433,11.178},
{6.90983,-21.2663,11.178},{17.2048,12.5,13.1409},{-6.57164,20.2254,13.1409},{-21.2663,-2.0716e-006,13.1409},{-6.57164,-20.2254,13.1409},
{17.2048,-12.5,13.1409},{23.7764,7.72543,-0.00233621},{14.6946,20.2254,-0.00233621},{-1.09278e-006,25.0,-0.00233621},{-14.6946,20.2254,-0.00233621},
{-23.7764,7.72542,-0.00233621},{-23.7764,-7.72542,-0.00233621},{-14.6946,-20.2254,-0.00233621},{2.98122e-007,-25.0,-0.00233621},{14.6946,-20.2254,-0.00233621},
{23.7764,-7.72542,-0.00233621},{0.0,0.0,-0.00233621}} ; 

float ModelSky_mapping[44][2] = {
{0.5,1.25894},{0.75,1.10974},{0.95,1.10974},{0.15,1.10974},{0.35,1.10974},
{0.55,1.10974},{0.75,0.706702},{0.95,0.706702},{0.15,0.706702},{0.35,0.706702},
{0.55,0.706702},{0.85,0.785141},{0.05,0.785141},{0.25,0.785141},{0.45,0.785141},
{0.65,0.785141},{0.8,0.259936},{0.9,0.259936},{1.0,0.259936},{0.1,0.259936},
{0.2,0.259936},{0.3,0.259936},{0.4,0.259936},{0.5,0.259936},{0.6,0.259936},
{0.7,0.259936},{1.00096,0.166575},{-0.0500001,1.10974},{-0.0500001,1.10974},{-0.0500001,0.706702},
{-0.0500001,1.10974},{0.0,0.259936},{-0.0500001,0.706702},{0.0,0.259936},{0.811584,0.230201},
{0.505161,0.254503},{0.198738,0.230201},{0.0093577,0.166575},{0.0093577,0.0879288},{0.198738,0.0243029},
{0.505161,0.0},{0.811584,0.0243029},{1.00096,0.0879288},{0.505161,0.127252}} ; 


int ModelSky_faces[50][3] = {
{2,1,3},{3,1,4},{4,1,5},{5,1,6},{6,1,2},{3,12,2},{4,13,3},{5,14,4},{6,15,5},{2,16,6},
{16,2,7},{7,2,12},{12,3,8},{8,3,13},{13,4,9},{9,4,14},{14,5,10},{10,5,15},{15,6,11},{11,6,16},
{12,17,7},{8,18,12},{13,19,8},{9,20,13},{14,21,9},{10,22,14},{15,23,10},{11,24,15},{16,25,11},{7,26,16},
{26,7,17},{17,12,18},{18,8,19},{19,13,20},{20,9,21},{21,14,22},{22,10,23},{23,15,24},{24,11,25},{25,16,26},
{26,17,27},{17,18,27},{18,19,27},{19,20,27},{20,21,27},{21,22,27},{22,23,27},{23,24,27},{24,25,27},{25,26,27}
} ; 


int ModelSky_Normals[50][3] = {
{-0.268035,-0.194739,-0.943522},{0.10238,-0.315094,-0.943522},{0.331309,0.0,-0.943522},{0.10238,0.315094,-0.943522},{-0.268035,0.194739,-0.943522},{-0.491123,-0.356822,-0.794654},{0.187593,-0.57735,-0.794654},{0.607062,0.0,-0.794654},{0.187592,0.57735,-0.794654},{-0.491124,0.356822,-0.794654},
{-0.724043,0.194739,-0.661694},{-0.724043,-0.194739,-0.661694},{-0.408949,-0.628428,-0.661694},{-0.038534,-0.748783,-0.661694},{0.471299,-0.583129,-0.661694},{0.700228,-0.268035,-0.661694},{0.700228,0.268035,-0.661694},{0.471298,0.583129,-0.661694},{-0.0385341,0.748783,-0.661694},{-0.408949,0.628428,-0.661694},
{-0.889698,-0.315094,-0.330384},{-0.574604,-0.748783,-0.330384},{0.0247404,-0.943522,-0.330384},{0.534573,-0.777868,-0.330384},{0.904988,-0.268035,-0.330384},{0.904988,0.268035,-0.330384},{0.534573,0.777868,-0.330384},{0.0247403,0.943522,-0.330384},{-0.574604,0.748783,-0.330384},{-0.889698,0.315094,-0.330384},
{-0.992078,0.0,-0.125624},{-0.794654,-0.57735,-0.187593},{-0.306569,-0.943522,-0.125624},{0.303531,-0.934172,-0.187593},{0.802608,-0.583129,-0.125624},{0.982247,1.21255e-007,-0.187593},{0.802608,0.583129,-0.125624},{0.303531,0.934172,-0.187593},{-0.306569,0.943522,-0.125624},{-0.794655,0.57735,-0.187593},
{0.0,0.0,1.0},{0.0,0.0,1.0},{0.0,0.0,1.0},{0.0,0.0,1.0},{0.0,0.0,1.0},{0.0,0.0,1.0},{0.0,0.0,1.0},{0.0,0.0,1.0},{0.0,0.0,1.0},{0.0,0.0,1.0}
} ; 


int ModelSky_mapfaces[50][3] = {
{2,1,3},{28,1,4},{4,1,5},{5,1,6},{6,1,2},{3,12,2},{4,13,29},{5,14,4},{6,15,5},{2,16,6},
{16,2,7},{7,2,12},{12,3,8},{30,31,13},{13,4,9},{9,4,14},{14,5,10},{10,5,15},{15,6,11},{11,6,16},
{12,17,7},{8,18,12},{13,32,33},{9,20,13},{14,21,9},{10,22,14},{15,23,10},{11,24,15},{16,25,11},{7,26,16},
{26,7,17},{17,12,18},{18,8,19},{34,13,20},{20,9,21},{21,14,22},{22,10,23},{23,15,24},{24,11,25},{25,16,26},
{43,27,44},{27,35,44},{35,36,44},{36,37,44},{37,38,44},{38,39,44},{39,40,44},{40,41,44},{41,42,44},{42,43,44}
} ; 



int ModelSky_nFace = 50 ;
CSky::CSky() 
{
	if ( m_nTexID < 0)	
		m_nTexID = FRAMEWORK->CreateTextureID( sky_png, FALSE) ;
   SetUp( m_nTexID, ModelSky_nFace, ModelSky_vertex, ModelSky_mapping, 
	      	 ModelSky_faces, ModelSky_mapfaces) ;
}

// ---------------------------------------------------------------------
CShadow::CShadow()
{
   m_nPass = 1 ;
	if ( m_nTexID < 0)	
		m_nTexID = FRAMEWORK->CreateTextureID( shadow_png, TRUE) ; 
}

// ---------------------------------------------------------------------
void     
CShadow::SetSource( CGraphicObject* source) 
{
   float w,h, x, y, z ;
   
   m_pSource = source ;
   if ( source == NULL) 
      return ;
   z = source->m_ptMax.z - source->m_ptMin.z ;
   x = source->m_ptMin.x ;
   y = source->m_ptMin.y ;
   w = source->m_ptMax.x-x ;
   h = source->m_ptMax.y-y ;
   x -= z*0.5 ;
   w += z ;
   y -= z*0.5 ;
   h += z ;
   modelTitle_vtx[0][0] = x+w ;
   modelTitle_vtx[0][1] = y ;
   modelTitle_vtx[0][2] = 0.01 ;
   
   modelTitle_vtx[1][0] = x+w ;
   modelTitle_vtx[1][1] = y+h ;
   modelTitle_vtx[1][2] = 0.01 ;

   modelTitle_vtx[2][0] = x ;
   modelTitle_vtx[2][1] = y+h ;
   modelTitle_vtx[2][2] = 0.01 ;
   
   modelTitle_vtx[3][0] = x ;
   modelTitle_vtx[3][1] = y ;
   modelTitle_vtx[3][2] = 0.01 ;
   
   SetUp( m_nTexID, Model_nFace, modelTitle_vtx, Model_mapping, 
          Model_faces, Model_mapfaces) ;
}

// ---------------------------------------------------------------------
void     
CShadow::Render()
{
   if ( m_pSource == NULL) 
      return ;
      
	Mtx modelview ;
	
	if ( m_pSource->m_bOnScreen) {
	   // no camera matrix
		GX_LoadPosMtxImm(m_pSource->m_model, GX_PNMTX0);    
		
	} else {
	   // camera transformation
		guMtxConcat( CAMERA->m_view, m_pSource->m_model, modelview);   
	   // load the modelview matrix into matrix memory
		GX_LoadPosMtxImm(modelview, GX_PNMTX0);    
	}
   // call unreferenced drawing	
	OnRender() ;
}
