/****************************************************************************
*	EK's ITALIAN parking                                                *
*	17.04.09  sidewalk.cpp             				    *
* 	        				                            *
****************************************************************************/

#include "..\include\SideWalk.h"
#include "..\include\framework.h"
#include "SideWalk_png.h"

int CSideWalk::m_nTexID = -1 ;

float ModelSideWalk_vertex[9][3] = {
      {0.0, 0.0, 0.2},{0.5, 0.0, 0.2},{ 1.0, 0.0, 0.2},
      {0.0, 0.5, 0.2},{0.5, 0.5, 0.2},{ 1.0, 0.5, 0.2},
      {0.0, 1.0, 0.2},{0.5, 1.0, 0.2},{ 1.0, 1.0, 0.2}} ;
      
float ModelSideWalk_mapping[8][2] = {
{0.0,1.0},{0.0,0.5},{0.5,1.0}, {0.5,0.5},
{0.0,0.49},{0.0,0.0},{0.5,0.49}, {0.5,0.0} 
} ; 

int   ModelSideWalk_faces[8][3] = {
{1,2,5},{2,3,5}, 
{3,6,5},{6,9,5},
{9,8,5},{8,7,5},
{7,4,5},{4,1,5}
} ; 

int   ModelSideWalkVert_mapfaces[8][3] = {
{2,4,3},{2,4,1}, 
{2,4,3},{2,4,1}, 
{2,4,3},{2,4,1}, 
{2,4,3},{2,4,1}
} ; 

int   ModelSideWalkHor_mapfaces[8][3] = {
{1,2,4},{1,2,3}, 
{1,2,4},{1,2,3}, 
{1,2,4},{1,2,3}, 
{1,2,4},{1,2,3}
} ; 

int   ModelSideWalkHorNo_mapfaces[8][3] = {
{5,6,8},{5,6,7}, 
{5,6,8},{5,6,7}, 
{5,6,8},{5,6,7}, 
{5,6,8},{5,6,7}
} ; 

int   ModelSideWalk_nFace = 8 ;

// --------------------------------------------------------------------------
CSideWalk::CSideWalk() 
{
   if ( m_nTexID < 0)
      m_nTexID  = FRAMEWORK->CreateTextureID( SideWalk_png, TRUE) ;    
   SetUp( m_nTexID, 0, 0, 0, 0, 0) ;
}

// --------------------------------------------------------------------------
void 
CSideWalk::Create( int nDesc) 
{

   int   nFlag ;
   int   i ;

   if ( m_nFaces) {
      free( m_Model_vertex) ;
//      free( m_Model_mapping) ;
//      free( m_Model_faces) ;
      free( m_Model_mapfaces) ;
   }
      
   m_nFaces = 8 ;
   m_Model_vertex = (float*)malloc(sizeof(float)*3*9) ; // 2 init + 2 for char
   m_Model_mapfaces = (int*)malloc(sizeof(int)*3*8) ; // mapping

   memcpy( m_Model_vertex, ModelSideWalk_vertex, sizeof(float)*3*9) ;
   memcpy( m_Model_mapfaces, ModelSideWalkVert_mapfaces, sizeof(int)*3*8) ;
   m_Model_mapping = (float*) ModelSideWalk_mapping ;
   m_Model_faces = (int*)ModelSideWalk_faces ;
   
   nFlag = 1 ;
   for ( i=0; i<9; i++) {
      if ( (nDesc & nFlag) == 0) {
         m_Model_vertex[i*3+2] = 0.0 ;
      }
      nFlag *= 2 ;
   }   
}


